#!/usr/bin/env python3

import subprocess

class command():
    def __init__(self):
        pass
    
    def initialize(self, environment):
        self.env = environment
    
    def shutdown(self):
        pass
    
    def getDescription(self):
        return "Test current voice configuration"
    
    def run(self):
        # Get current speech settings
        driver = self.env['runtime']['settingsManager'].getSetting('speech', 'driver')
        module = self.env['runtime']['settingsManager'].getSetting('speech', 'module')
        voice = self.env['runtime']['settingsManager'].getSetting('speech', 'voice')
        rate = self.env['runtime']['settingsManager'].getSetting('speech', 'rate')
        pitch = self.env['runtime']['settingsManager'].getSetting('speech', 'pitch')
        volume = self.env['runtime']['settingsManager'].getSetting('speech', 'volume')
        
        # Present current configuration
        self.env['runtime']['outputManager'].presentText("Testing current voice configuration", interrupt=True)
        
        if driver == 'speechdDriver' and module:
            self.env['runtime']['outputManager'].presentText(f"Driver: {driver}", interrupt=True)
            self.env['runtime']['outputManager'].presentText(f"Module: {module}", interrupt=True)
            if voice:
                self.env['runtime']['outputManager'].presentText(f"Voice: {voice}", interrupt=True)
        
        try:
            ratePercent = int(float(rate) * 100)
            self.env['runtime']['outputManager'].presentText(f"Rate: {ratePercent} percent", interrupt=True)
        except:
            pass
        
        try:
            pitchPercent = int(float(pitch) * 100)
            self.env['runtime']['outputManager'].presentText(f"Pitch: {pitchPercent} percent", interrupt=True)
        except:
            pass
        
        try:
            volumePercent = int(float(volume) * 100)
            self.env['runtime']['outputManager'].presentText(f"Volume: {volumePercent} percent", interrupt=True)
        except:
            pass
        
        # Test message
        testMessage = "This is a test of your current voice configuration. The quick brown fox jumps over the lazy dog. Numbers: one, two, three, four, five. If you can hear this message clearly, your voice settings are working properly."
        
        self.env['runtime']['outputManager'].presentText("Voice test:", interrupt=True)
        self.env['runtime']['outputManager'].presentText(testMessage, interrupt=True)
        self.env['runtime']['outputManager'].playSound('Accept')
    
    def setCallback(self, callback):
        pass